<?php

if (!defined('__ADMIN_INC__')) {
    define('__ADMIN_INC__', 1);	

	// Check for previous cat
	function CheckForPrevCat($CatId=-1)		{
		if($CatId<=0)	{ return false; }
		
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		$sql = "SELECT catid FROM cf_categories WHERE catprev='".$CatId."'"; 
		$data = $DB->dbselect($sql);			
				
		if($data)	{
			return false;		
		} else { return true; }
	}

	function TestCategory($CatNameIn="")		{
		
		if(empty($CatNameIn))	{
			return false;
		}
		
		$sql = "SELECT COUNT(*) AS Anzahl FROM cf_categories WHERE catname='".$CatNameIn."'";
		
		global $DEBUG;
		if($DEBUG==true)	{
			echo "SQL SELECT String: ".$sql."<br>";	
		}		
				
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		// Delete Categories
		$data = $DB->dbselect($sql);
		if($data) 	{
			foreach($data as $element)	{
				if($element['Anzahl']>0)	{	
					if($DEBUG==true)	{
						echo "Amount of found categories: ".$element['Anzahl'];
					}
					$RetVal=false;	
				}
				else
				{
					$RetVal = true; 			// Success
				}
			}
		} else {$RetVal = true; }
		
		return $RetVal;
	}
	
	function AddCategoryByName($CatNameIn="", $CatDesc="",$CatLink="", $bAgeRest=false, $PrevCat=-1)			{
		
		if(empty($CatNameIn))	{ return false; }
		
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{ return false;	}
		
		// Add category to database
		$sql = "INSERT INTO cf_categories (catname,catdesc,caticonlink,catagerestricted,catprev) VALUES ('";
		$sql.= $CatNameIn."','".$CatDesc."','".$CatLink."','".($bAgeRest==true ? 1 : 0)."',";
		$sql.= ($PrevCat<=0 ? "null" : "'".$PrevCat."'").")";
		
		$RetVal = false;
		$RetVal = $DB->dbinsert($sql);
		
		if($RetVal >0)		{
			$RetVal = true;	
		}
		
		return $RetVal;
	}
	
	function EditCategory($IDIn=-1,$CatName="",$CatDesc="",$CatLink="",$CatDelete=false,$AgeRest="",$PrevCat=0)		{
		// Edit Category data
		
		// Catch wrong ID parameters
		if(is_int($IDIn)==false && is_string($IDIn)==false)	{ return false; }
		if($IDIn <=0)		{ return false; }
			
		// First read original data
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{ return false;	}
		
		// Read Categories
		$sql = "SELECT catname,catdesc,caticonlink,catagerestricted from cf_categories WHERE Catid ='".$IDIn."'";
		$data = $DB->dbselect($sql);
		
		if($data===false)	{
			return false;				// Database error
		}
		
		
		foreach($data as $element)
		{
			$CatName_org = $element['catname'];
			$CatDesc_org = $element['catdesc'];
			$CatLink_org = $element['caticonlink']; 
						
			if($AgeRest=="2")		{
				$AgeRestSQL = $element['catagerestricted'];
			} elseif($AgeRest=="1")	{
				$AgeRestSQL = 1;
			} else { $AgeRestSQL = 0; }	
		}
		
		// Mix variables of input parameters and database data
		if(empty($CatName))		{$CatName=$CatName_org;}
		if(empty($CatDesc))		{$CatDesc=$CatDesc_org;}
		if(empty($CatLink))		{$CatLink=$CatLink_org;}
		
		if($CatDelete===true)	{
			// Delete Catlogo
			$CatLink="";
		}

		// Build SQL-String
		$sql = "UPDATE cf_categories SET catname='".$CatName."',".
			"catdesc = '".$CatDesc."', caticonlink = '".$CatLink."', ".
			"catagerestricted = '".$AgeRestSQL."', ".
			"cateditdate=now()";
		if($PrevCat!=0)	{
			if($PrevCat < 0)	{
				$sql.= ", catprev = null ";
			} else {
				$sql.= ", catprev = '".$PrevCat."' ";	
			}
		}
		$sql.= "WHERE catid='".$IDIn."'";
		
		// Query
		$RetVal = $DB->dbupdate($sql);
						
		if($RetVal==false)	{ return $RetVal;	
		} else { return true;	}
	}

	function ToogleAgeRestricted($iAdId)	{
		
		// Connect database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}

		$sql = "UPDATE cf_ads SET ".
			"adagerestricted = IF(adagerestricted=1,0,1) ".
			"WHERE adid=".$iAdId;
		$iAffRows = $DB->dbupdate($sql);

		return ($iAffRows>0?TRUE:FALSE);	
	}

	function ToogleFeatured($iAdId)	{
		
		// Connect database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}

		$sql = "UPDATE cf_ads SET ".
			"adfeatured = IF(adfeatured=1,0,1) ".
			"WHERE adid=".$iAdId;
		$iAffRows = $DB->dbupdate($sql);

		return ($iAffRows>0?TRUE:FALSE);	
	}

	
	function DeleteCategory($IDIn=-1,$Subitems=false)		{
		
		// No input, no output ;-)
		if(is_int($IDIn)==false && is_string($IDIn)==false)	{
			return false;
		}
		
		if($IDIn <=0)		{
			return false;
		}
		
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		$RetVal=false;
		
		// Delete Categories
		$sql = "DELETE from cf_categories WHERE catid='".$IDIn."'";
		$RetVal = $DB->dbdelete($sql);
				
		if(($Subitems==true))		{
		
			// Delete all messages previously attacheted to deleted category
			// but only if category was deleted properly
			
			$sql = "SELECT adid,adpiclink FROM cf_ads WHERE adcat='".$IDIn."'"; 
			$data = $DB->dbselect($sql);			
		
			if($data)	{
				foreach($data as $element)	{
					if(empty($element['adpiclink']))	{	
						DeleteArticle($element['adid'],false);
					} else {
						DeleteArticle($element['adid'],true,$element['adpiclink']);
					}
				}
			}
		}
		return $RetVal;
		
	}

	///////////////
	// function   :		GetActionLogOptions()
	//					Builds an option list with all available logfile actions
	//
	// parameters :		-		
	//
	// return     :		returns optionlist or empty string					
	///////////////
	function GetActionLogOptions($SelectedAction="")		{
		
		$ActionArray = array( 	"SRCP","Performed searches",
								"LOG","Successful logins",
								"FLDLOG","Failed logins",
								"USRA","New user added to database",
								"USRD","User deleted from database",
								"USRE","User edited",
								"MSGA","Message added",
								"MSED","Message edited",
								"MSGD","Message deleted"	);
		
		$OptionList="";						
		for($i=0;$i<sizeof($ActionArray);$i=$i+2)	{
			$OptionList .= "<option value=\"".$ActionArray[$i]."\"".
				($ActionArray[$i]==$SelectedAction ? " selected":"").">".
				$ActionArray[$i+1]."</option>";
		}
		return $OptionList;
	}
	
	///////////////
	// function   :		GetActionsFromDB()
	//					Builds an array with logentries
	//
	// parameters :		-		
	//
	// return     :		returns an result array or false					
	///////////////
	function GetActionsFromDB($LogType="",$Limit=1000)		{
		
		if($LogType == "")		{
			return false;
		}
		
		if(is_int($Limit)==false || is_string($Limit)==false || $Limit=="")	{
			$Limit=2000;
		}
		
		$sql = "SELECT * FROM cf_actions WHERE actiontype='".$LogType."' ORDER BY actiontime DESC LIMIT ".$Limit;
	
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		$result = $DB->dbselect($sql);
		if($result)		{ return $result; }
		else { return false; }
	}
	
	
	///////////////
	// function   :		DeleteActionsFromDB()
	//					Delete Action entries from DB
	//
	// parameters :		-		
	//
	// return     :		returns an result array or false					
	///////////////
	function DeleteActionsFromDB($LogType="")		{
		if($LogType == "")	{ return false; }
				
		$sql = "DELETE FROM cf_actions WHERE actiontype='".$LogType."'";
	
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		$result = $DB->dbdelete($sql);
		if($result)		{ return $result; }
		else { return false; }
		
	}



	///////////////
	// function   :		ToogleBlockStatus($UID=-1)
	//					Toggles a users blocked status on/off
	//
	// parameters :		$UID			UserID
	//				
	// return     :		returns true or false in case of an error					
	///////////////
	function ToogleBlockStatus($UID=-1)		{
		
		// Check parameters
		if($UID<=0)  { return false; }

		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		$sql = "UPDATE cf_users SET ".
			"userblocked = IF(userblocked=1,0,1) ".
			"WHERE userid=".$UID;
		$result = $DB->dbupdate($sql);	
		return $result;
	}

	
	function ToogleClosedUsergroup($UID=-1)		{
		
		// Check parameters
		if($UID<=0)  { return false; }

		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		$sql = "UPDATE cf_users SET ".
			"useragechecked = IF(useragechecked=1,0,1) ".
			"WHERE userid=".$UID;
		$result = $DB->dbupdate($sql);	
		return $result;
	}
	
	
	function ToogleAuthUser($UID=-1)		{
		
		// Check parameters
		if($UID<=0)  { return false; }

		// Open database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
		
		$sql = "UPDATE cf_users SET ".
			"userrights = IF(userrights & 2=2 ,userrights -2, userrights +2) ".
			"WHERE userid=".$UID;
		$result = $DB->dbupdate($sql);	
		return $result;
	}
	
	

	///////////////
	// function   :		DeleteUser($UID=-1,$CommercialTest=false)
	//					Deletes a user from database
	//
	// parameters :		$UID				UserID to delete
	//					$CommercialTest		Should there be a test, to ensure no
	//					available money or ad space is left
	//				
	// return     :		returns true (affected rows) or false in case of an error
	//					-1 for failed CommercialTest					
	///////////////
	function DeleteUser($UID=-1,$CommercialTest=false)		{
		// Check input
		if($UID <= 0)	{ return false; }
		
		// Do a commercial test
		if($CommercialTest)		{
			// ************
			// classAd 3.0
		}
				
		// Query database
		$DB = new SQLDatabase();
		$DB->dbconnect();
		if($DB==false)	{
			return false;				// Database error
		}
				
		// Delete Categories
		$sql = "DELETE from cf_users WHERE userid='".$UID."'";
		$RetVal = $DB->dbdelete($sql);
			
		return $RetVal;
		
	}


}

?>