<?php

	if (!defined('__MAINTAIN_INC__')) {
   		define('__MAINTAIN_INC__', 1);	

   	
   		class Maintain	{
			
   			// Pseudo-constants
   			var $MAX_ACTIVATION_DAYS = 14;
   			var $SOFTLIMIT_DAYS = 5;
   			var $ALTER_PASSWORD_DAYS = 2;
   			
   			// Result counters
   			var $iDeletedUsers = 0;
   			var $iDeletedOutdated = 0;
   			
   			
   			function GetDeletedUsers()	{	return $this->iDeletedUsers;	}
   			function GetDeletedOutdated()	{ return $this->iDeletedOutdated; }

   			
   			/**
   			 * Update / destroy first and second level category cache
   			 *
   			 * @return boolean Success
   			 */
   			function UpdateCache()	{
   				
   				require_once("inc/adv_categories.inc.php");
				require_once("inc/simple_categories.inc.php");
								
				//
				// Update main cache
				//
				$oCatManager = new CatTreeManager();
				$oCatManager->UpdateCache();
				$oRoot = $oCatManager->GetTreeRoot();
				
				$oTreeWork = new CategoryTreeWorks($oRoot);
				$oTreeWork->UpdateCategoryStatistics();
				
				//
				// Delete cache files from distributed cache
				//
				$oCatSimple = new SimpleCategoryManager();
				$oCatSimple->DeleteCache();
   			
   				return TRUE;
   			}
   			
   			   			
   			/**
   			 * Delete alternative passwords, if they are not used for some time
   			 *
   			 * @return boolean Success
   			 */
   			function DeleteAlterPasswords()	{
  				 				
   				$DB = new SQLDatabase();
				if(!$DB->dbconnect())	{
					return FALSE;
				}
   				
				$sql = "UPDATE cf_users SET ".
					"useralterpass='', userpasswordset=NULL ".
					"WHERE DATE_ADD(userpasswordset, INTERVAL ".$this->ALTER_PASSWORD_DAYS." DAY) < now()";
				$iAffRows = $DB->dbupdate($sql);
				
				return TRUE;
   			}
   			
   			
   			/**
   			 * Deletes all non-activated user
   			 *
   			 * @return boolean Success
   			 */
   			function DeleteInactiveUsers()	{
   				
   				$DB = new SQLDatabase();
				if(!$DB->dbconnect())	{
					return FALSE;
				}
   				
				$sql = "DELETE FROM cf_users ".
					"WHERE userreleased=0 AND ".
					"DATE_ADD(usercreatedate, INTERVAL ".$this->MAX_ACTIVATION_DAYS." DAY) < now() ";
				$this->iDeletedUsers = $DB->dbdelete($sql);
				
   				return TRUE;
   			}

   			/**
   			 * Deletes all outdated ads 
   			 *
   			 * @param boolean Prolongs the ads' outdates for some days
   			 * @return boolean Success
   			 */
   			function DeleteOutdatedAds($bSoftLimit=TRUE)	{	
   			
   				$DB = new SQLDatabase();
				if(!$DB->dbconnect())	{
					return FALSE;
				}
   				
				$sql = "DELETE FROM cf_ads ".
					"WHERE adfeatured=0 AND ".
					"adoutdate < DATE_SUB(now(), INTERVAL ".($bSoftLimit?$this->SOFTLIMIT_DAYS:0)." DAY) ";
				$this->iDeletedOutdated = $DB->dbselect($sql);
				
				return TRUE;
   			}
   			   			
   		}
	}   		
   		
?>