<?php

	/**
	 *	Template class
	 * 	
	 * 	Mini template class to display the correct template
	 * 	for the current language	  
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */
	class Template	{
		
		var $strTemplate = "";
		var $strLanguage = "GER";
		
		var $strTemplateDir = "templates";
		
		var $strLastError = "";
		
		
		/**
		 * Template constructor
		 *
		 * @param string template filename
		 * @param string active language
		 * @return Template
		 */
		function Template($strTemplate,$strLanguage="GER")		{
			$this->strTemplate = $strTemplate;
			$this->strLanguage = $strLanguage;	
		}
		
		
		function SetTemplateDir($strDirectory)	{
			$this->strTemplateDir = $strDirectory;
		}
		
		function GetLastError()	{
			return $this->strLastError;
		}
	
		
		/**
		 * Show template
		 * 
		 * @access public
		 * 
		 */
		function Show()		{

			if(!$this->CheckTemplate())		{
				$this->strLastError = "Checking template failed - not exisiting or unreadable. Template file: ".$this->GetTemplateFileName();
				return FALSE;				
			} else {
				include ($this->GetTemplateFileName());
			}
			
			return TRUE;			
		}
		
		
		/**
		 * Check template for existance and readablilty
		 *
		 * @access protected
		 * @return bool If the template is existing and readable, TRUE is returned otherwise FALSE
		 * 
		 */
		function CheckTemplate()	{
			
			$strFile = $this->GetTemplateFileName();			
			
			if(!is_file($strFile) || !is_readable($strFile))	{	
				return FALSE;
			} 
			
			return TRUE;
		}
		
		
		function GetTemplateFileName()	{
			return ($this->strTemplateDir."/".
				strtoupper($this->strLanguage)."/".
				$this->strTemplate.".tpl.php");
		}
		
	}
	
?>