<?php		

	/**
	 *	Display category overview
	 * 
	 *	@package 	ClassAd
	 *	@author 	cts projects&software <classad@projects-and-software.de>
	 *	@copyright 	cts projects&software 2002-2006
	 *	@copyright	All rights reserved
	 *	@version	4.00
	 * 
	 */


	require "inc/includer.inc.php";
	require_once("inc/guielements.inc.php");
	
	//
	// Init variables
	//
	$iCatID = -1;
	$iPage = 1; $iStart = 0; $iListLength = 0;
	$bSecurityCheck = FALSE;
	$iSortOrder = AD_ORDER_INDATE_DESC;
	$iAdTypes = -1;
	$strBreadCrumb = "";
	$strCatThumbLink = "";
	
	// Check, if there is a valid variable for category search
	if(isset($_GET['catid']))		{
	   	
	   	$iCatID = (integer)$_GET['catid'];
	   	
		// Invalid category id
		if($iCatID<=0)	{
			echo LANG_PAGEPARAMETERERROR;			
			die();
		} else {
			$_SESSION['s_LastCategory'] = $iCatID;
		}

	} elseif($_SESSION['s_LastCategory'])	{

		$iCatID = (integer)$_SESSION['s_LastCategory'];
	
	} else {
		// Fatal error, no category id set	
		echo LANG_PAGEPARAMETERERROR;
		die();
	}
	
	
	// Get page
	$iListLength = $GLOBALS['LY_MAX_LISTLENGTH'];
	if(!isset($_GET['page']) || (integer)($_GET['page']<=0))	{
		$iPage = 1; $iStart = 0;
	} else {
		$iStart = ((integer)$_GET['page']-1) * $iListLength;
		$iPage = $_GET['page'];
	}
	
	// Get Title
	$CatArray = GetCategorieByID($iCatID);

	
	// Header senden
	$PageTitle = GetPageTitle(ParseIn(LANG_TTLCATLIST, (isset($CatArray['catname'])?$CatArray['catname']:"")));
	include "inc/header.inc.php";
	
	// Security check, category age restricted
	if($GLOBALS['SEC_FORCE_AGE_REST'] && $CatArray['catagerest']==1)	{
		
		if($GLOBALS['DEBUG'])	{ echo "This category is age controlled!<br>User is ".
			($_SESSION['s_UserInfo']['useragechecked']=="1" ? "over 18":"under 18")."<br>"; 
		}
		
		// Yes, we have to check the age of user
		if(!is_array($_SESSION['s_UserInfo']) || $_SESSION['s_UserInfo']['useragechecked']!=1)		{
			// Redirect to login
			$bError=true;
			$strMessage = LANG_CATVIEWNOTALLOWED;
			include "templates/".$GLOBALS['ACTIVELANGUAGE']."/userloginpage.tpl.php";
			die();
		}
	}
	
	// Get user security
	if($GLOBALS['SEC_HIDE_AGEREST_CATS'] && $GLOBALS['SEC_FORCE_AGE_REST'])	{
		// Check user security
		if(isset($_SESSION['s_UserInfo']) && $_SESSION['s_UserInfo']['useragechecked'])	{
			// User checked ok
			$bSecurityCheck = FALSE;
		} else {
			// User not authenticated or has proper rights
			$bSecurityCheck = TRUE;	
		}
	} else {
		// Show all category entries
		$bSecurityCheck = FALSE;	
	}		

	
	//
	// Process form
	//
	if(isset($_POST['send']) && strtoupper($_POST['send'])=="YES")	{
		if(isset($_POST['btnSetSort']))	{
			$iSortOrder = (integer)$_POST['f_sortorder'];
			$_SESSION['s_AdSortOrder'] = $iSortOrder;

			$iAdTypes = (integer)$_POST['f_adtype'];
			$_SESSION['s_AdTypeFilter'] = $iAdTypes;
			
			$iPage = 1;
		}
	} else {
		if(isset($_SESSION['s_AdSortOrder']))	{
			$iSortOrder = (integer)$_SESSION['s_AdSortOrder'];			
		}
		
		if(isset($_SESSION['s_AdTypeFilter']))	{
			$iAdTypes = (integer)$_SESSION['s_AdTypeFilter'];
		}
	}

	
	// Build title entries
	$CatIconLink = (!empty($CatArray['caticonlink']) ? "<img src=\"".$GLOBALS['PD_DIRCATLOGOS'].$CatArray['caticonlink']."\" style=\"float:right;\"> " : "");
	$CatTitle = $CatArray['catname'];
	$CatDesc = (!empty($CatArray['catdesc']) ? $CatArray['catdesc'] : "");
	$SubCatDirectory = "";

	// Do we have to build a sub-category (complex) list?!	
	if(!$GLOBALS['OP_SIMPLE_CATS'])	{
		
		// **************** SECURITY FEATURES MISSING
		//$SubCatArray = BuildCatOverviewFromDB($iCatID, $GLOBALS['LY_SORT_ORDER_CATS'], $bSecurityCheck);
		
		$oSCM = new SimpleCategoryManager($iCatID);
		$SubCatArray = $oSCM->GetCategoryOverview();

		// Build cat history
		$strBreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a>".
			BuildCatHistory($CatArray['catprev'])." &gt; ".$CatArray['catname'];
		
		// Read categories structed from database
		$SubCatDirectory ="<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">".
			"<tr><th width=\"25%\">".LANG_FIELDSUBCAT."</td>".
			"<th width=\"75%\">".LANG_FIELDSUBCATDESC."</td></tr>";	
		
		if(is_array($SubCatArray) && sizeof($SubCatArray)>0)	{
			
			$i=0;
				
			foreach($SubCatArray as $arrSubElement)	{

				$oSubCategory = $arrSubElement['ELEMENT'];
					
				// Mark new categories as NEW!
				$LatestIn = $oSubCategory->dtLastIn;
				$NewPic = "";	
				if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))	{
					// Known user / logged in			
					if($LatestIn >= $_SESSION['s_UserInfo']['userlastlogin']) {
							$NewPic = "<img src= \"".$GLOBALS['PD_SCRIPTGRAPHICS']."new.gif\" alt=\"".
								LANG_INDEXNEWARTICONNEW."\">";	
					} 
				} 
		
				$SubCatDirectory .= "<tr class=\"".($i%2!=0?"highlighted":"nonhighlighted")."\">".
					"<td style=\"padding-top:3px;padding-bottom:3px;\">".
					"<img src= \"".$GLOBALS['PD_SCRIPTGRAPHICS']."pointer.gif\" border = \"0\" >".
					"<a href=\"showads.php?catid=".$oSubCategory->iId."\">".
					" ".$oSubCategory->strName."</a>".
					" (".($oSubCategory->iAdCountCum + $oSubCategory->iAdCount).") ".$NewPic."</td>".
					"<td>".$oSubCategory->strDesc." ".
						ParseIn(LANG_FIELDADDSUBCATS, $oSubCategory->iChildCatCount)."</td>".
					"</tr>";
				
				$i++;
			}
		} else {
			$SubCatDirectory.= "<tr><td colspan=\"2\" align=\"center\">".LANG_NOMORESUBCATSFOUND."</td></tr>";	
		}		
		$SubCatDirectory.="</table>";
	} else {
		$strBreadCrumb = "<a href=\"index.php\">".LANG_FIELDMAINCATEGORY."</a> &gt; ".
			$CatArray['catname'];
	}
	


	// Open Database
	$DB = new SQLDatabase();
	$DB->dbconnect();
	if($DB==false)	{
		echo LANG_DBCONNECTERRORCUST;
		ShowErrorMessage($DBConnectErrorCust);    
		die();
	}

	// Build category page selector
	$iNumberOfArticles = GetCorrectedArticlesPerCat($iCatID, $bSecurityCheck, $iAdTypes);
	$CategoryMove = BuildCatMover($iNumberOfArticles, $iListLength, $iCatID, $iPage);	
	
	// Read Categories
	$sql = "SELECT adid,adzip,adtype,adcity,adtitle,adname,adpiclink,adchecked,adviewed,adindate,adagerestricted ".
		"FROM cf_ads ".
		"WHERE adcat=".$iCatID." AND adchecked=1 ";

	if($bSecurityCheck)		{	
		$sql.= "AND adagerestricted=0 ";
	}
		
	if($iAdTypes != (-1))	{
		$sql.= "AND adtype=".$iAdTypes." ";
	}
		
	// Order clause
	switch($iSortOrder)		{
		case AD_ORDER_TITLE:
			$sql.= "ORDER BY adtitle ";
			break;
		case AD_ORDER_TITLE_DESC:
			$sql.= "ORDER BY adtitle DESC ";
			break;
		case AD_ORDER_VIEWS:
			$sql.= "ORDER BY adviewed, adindate ";
			break;
		case AD_ORDER_VIEWS_DESC:
			$sql.= "ORDER BY adviewed DESC, adindate ";
			break;
		case AD_ORDER_PICTURES:
			$sql.= "ORDER BY adpiclink='', adindate DESC ";
			break;
		case AD_ORDER_PICTURES_DESC:
			$sql.= "ORDER BY adpiclink='' DESC, adindate DESC ";
			break;
		case AD_ORDER_INDATE:
			$sql.="ORDER BY adindate ";		
			break;
		default:
			$sql.= "ORDER BY adindate DESC ";
			break;
	}
	$sql.= "LIMIT ".$iStart.",".$iListLength;
	$data = $DB->dbselect($sql);
	
	$ArtTable = "<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"3\">".
		"<tr>".
		"<th width=\"7%\">".LANG_HEADLINEPICROW."</th>".
		"<th width=\"48%\">".LANG_HEADLINETITLEROW."</th>".
		"<th width=\"30%\">".LANG_HEADLINEWRITERROW."</th>".
		"<th width=\"10%\">".LANG_HEADLINEDATEROW."</th>".
		"<th width=\"5%\" align=\"right\">".LANG_HEADLINEADVIEWS."</th>".
		"</tr>";

	if(!is_array($data) || sizeof($data)==0)	{ 
		// No data or connection problems 
		$ArtTable .="<tr>".
			"<td colspan=\"5\">".
			"<div align=\"center\">".LANG_NODATAENTRY."</div>".
			"</td>".
			"</tr>"; 
	} else {

		// Show Articles
		$PrintLine = 0;

		// Walk through articles
		foreach($data as $element)
		{
			$SecurityOkay = true;
			if($GLOBALS['SEC_HIDE_AGEREST_ADS'] && $GLOBALS['SEC_FORCE_AGE_REST'] 
				&& $element['adagerestricted']=="1" )	{
				// Follow security guidelines and dont show age rest. ads
				
				if(!isset($_SESSION['s_UserInfo']) || !is_array($_SESSION['s_UserInfo']) 
					|| $_SESSION['s_UserInfo']['useragechecked'] != 1)		{
					$SecurityOkay = false;			
				}
			}
			
			if($element['adchecked']=="0")	{
				// Ad is not yet released from admin
				// Should never be reached, cause of sql-statement - its just to ensure
				$SecurityOkay = false;	
				if($GLOBALS['DEBUG'])	{ echo "Ad not show, cause not yet released by admin<br>"; }
			}

			if($SecurityOkay==true)	{
				
				$PrintLine++;
				$HighlightTag = ($PrintLine%2==0?"highlighted":"nonhighlighted");
								
				// add thumbnails
				$ThumbPic="";
				if(!empty($element['adpiclink']))	{
					$ThumbPic = "<a href=\"showad.php?adid=".$element['adid']."\">";
					$ThumbPic.= "<img src= \"".$GLOBALS['PD_USERGRAPHICS']."tn_".$element['adpiclink'].
						"\" border=\"0\"></a>";
				} else {
					$ThumbPic = "<img src=\"".$GLOBALS['PD_SCRIPTGRAPHICS']."no_image.gif\" alt=\"".LANG_NOPICAVAILABLE."\">";
				}
			
				// Special age control
				if($GLOBALS['SEC_FORCE_AGE_REST'] && $CatArray['catagerest']!="1" && $element['adagerestricted']=="1")	{
					$AgeRestIcon = "<img src= \"".$GLOBALS['PD_SCRIPTGRAPHICS']."alert.gif\" alt=\"".LANG_INDEXNEWARTICONADAGE."\" >";
				} else { 
					$AgeRestIcon=""; 
				}
			
				// add tabledata
				$ArtTable .= "<tr class=\"".$HighlightTag."\"><td width=\"7%\" align=\"center\">".$ThumbPic."</td>".
					"<td width=\"48%\">".$AgeRestIcon."<a href=\"showad.php?adid=".$element['adid']."\">".$element['adtitle']."</a>".
						"<br><span class=\"smallsubtitle\">".DecodeAdType($element['adtype'])."</span></td>".
	   				"<td width=\"30%\">".$element['adname']."<br>(".(!empty($element['adzip'])? $element['adzip']." ":"").
	   				$element['adcity'].")</td>";
	   			
	   			// add a picture, if this ad was entered after users last visit
	   			$NewPic = "";
	   			if(isset($_SESSION['s_UserInfo']) && is_array($_SESSION['s_UserInfo']))	{
					// Known user
					if($element['adindate'] >= $_SESSION['s_UserInfo']['userlastlogin']) {
						$NewPic = "<img src= \"".$GLOBALS['PD_SCRIPTGRAPHICS']."new.gif\" alt=\"".LANG_INDEXNEWARTICONNEW."\">";	
					} 
				} else {
					if(isset($COOKIE['adlastvisit']))		{
	   					// Cookie available, test, if entry is younger than last visit
	   					if($COOKIE['adlastvisit'] <= ($element['adindate']))	{
	   						$NewPic = "<img src= \"".$GLOBALS['PD_SCRIPTGRAPHICS']."new.gif\" alt=\"".LANG_INDEXNEWARTICONNEW."\">"; 	
	   					}
	   				}
	   			}
	   			
	   	 		$ArtTable .= "<td width=\"10%\">".FormatDate($element['adindate']).$NewPic."</td>".
	   	 			"<td width=\"5%\" align=\"right\">".$element['adviewed']."</td></tr>";
			}
		}
	}

	$ArtTable.= "</table>";
		
	
	//
	// Display template
	//
	$strOrderOptions = GetSortOrderForDropDown($iSortOrder);
	$TableTitle = LANG_SHOWADSTABLETITLE;
	$NumberOfArticles= ParseIn(LANG_SHOWADSARTICLECOUNT, $iNumberOfArticles);
	$strAdTypeSelect = GetAdTypesForDropDown($iAdTypes,TRUE,TRUE);

	include "templates/".$GLOBALS['ACTIVELANGUAGE']."/showads.tpl.php";
	
	// Categorietemplate
	include "inc/footer.inc.php";
?>